--- linux_socket.c.orig	Tue Jan 18 10:41:32 2005
+++ linux_socket.c	Tue Jan 18 11:02:37 2005
@@ -869,5 +869,48 @@
 	bsd_args.len = linux_args.len;
 	bsd_args.flags = linux_args.flags;
-	return (osend(td, &bsd_args));
+	if ( linux_args.flags & LINUX_MSG_NOSIGNAL )
+	{
+		/* requested to ignore pipe so set SO_NOSIGPIPE temporarily */
+		int ret_send, ret_opt;
+		struct setsockopt_args /* {
+			int s;
+			int level;
+			int name;
+			caddr_t val;
+			int valsize;  
+		} */ bsd_setsockopt_args;
+		caddr_t sg;
+        int *nosigpipe;
+
+        sg = stackgap_init();
+        nosigpipe = (int *)stackgap_alloc(&sg, sizeof(*nosigpipe));
+        *nosigpipe = 1;
+        bsd_setsockopt_args.s = linux_args.s;
+        bsd_setsockopt_args.level = SOL_SOCKET;
+        bsd_setsockopt_args.name = SO_NOSIGPIPE;
+        bsd_setsockopt_args.val = (caddr_t)nosigpipe;
+        bsd_setsockopt_args.valsize = sizeof(*nosigpipe);
+        ret_opt = setsockopt(td, &bsd_setsockopt_args);
+		if ( -1 == ret_opt )
+		{
+			return ret_opt;
+		}
+
+		ret_send = (osend(td, &bsd_args));
+		/* must clear the option */
+        *nosigpipe = 1;
+        bsd_setsockopt_args.val = (caddr_t)nosigpipe;
+        ret_opt = setsockopt(td, &bsd_setsockopt_args);
+		if ( -1 == ret_send || -1 == ret_opt )
+		{
+			return -1;
+		}
+
+		return ret_send;
+	}
+	else
+	{
+		return (osend(td, &bsd_args));
+	}
 }
 
